From dc2d4c37473be3848dfcf33e480b964cb4dd099d Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 03 2021 00:14:31 +0000
Subject: [PATCH 1990/2232] Mark error conversion function noexcept


This prevents a std::bad_alloc exception from operator new[] from
potentially propagating into Rust, which would be UB.

---

diff --git a/src/cxx.cc b/src/cxx.cc
index ccf44b2..9b4357c 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -351,7 +351,7 @@ static_assert(!std::is_same<Vec<std::uint8_t>::const_iterator,
               "Vec<T>::const_iterator != Vec<T>::iterator");
 
 extern "C" {
-const char *cxxbridge1$error(const char *ptr, std::size_t len) {
+const char *cxxbridge1$error(const char *ptr, std::size_t len) noexcept {
   char *copy = new char[len];
   std::strncpy(copy, ptr, len);
   return copy;

